.586
.model flat,stdcall
option casemap:none

include windows.inc
include kernel32.inc
include user32.inc
includelib kernel32.lib
includelib user32.lib

EH_NONCONTINUABLE		equ 1
EH_UNWINDING			equ 2
EH_EXIT_UNWIND			equ 4
EH_STACK_INVALID		equ 8
EH_NESTED_CALL			equ 16

EXCEPTION_REGISTRATION_XTN struc
	prev		DWORD ?
	handler		DWORD ?
	catcherlist	DWORD ?
	csfEbp		DWORD ?
EXCEPTION_REGISTRATION_XTN ends

try macro
	ifndef try_nr
		try_nr = 0
		cat_nr = 0
		fin_nr = 0
	else
		try_nr = try_nr + 1
		cat_nr = cat_nr + 1
		fin_nr = fin_nr + 1
	endif
	try_txt CATSTR <end_try_>,%try_nr
	cat_txt CATSTR <catcher_>,%cat_nr
	fin_txt CATSTR <final_block_>,%fin_nr
	assume FS:nothing
	push ebp
	% push offset cat_txt
	push offset ExceptionHandler
	push FS:[0]
	mov FS:[0],esp
endm

catch macro Exception
	% jmp try_txt
	% cat_txt:
	cat_nr = cat_nr + 1
	cat_txt CATSTR <catcher_>,%cat_nr
	cmp (EXCEPTION_RECORD ptr [ecx]).ExceptionCode,Exception
	% jne cat_txt
	mov (EXCEPTION_REGISTRATION_XTN ptr [edx]).catcherlist,@F
	mov eax,EXCEPTION_EXECUTE_HANDLER
	retn
	@@:
	mov esp,edx
endm

finally macro
	% jmp try_txt
	% fin_txt:
endm

endtry macro
	% ifdef fin_txt
		retn
	else
		% jmp try_txt
	endif
	% cat_txt:
	% ifdef fin_txt
		% call fin_txt
	endif
	mov eax,EXCEPTION_CONTINUE_SEARCH
	retn
	% try_txt:
	% ifdef fin_txt
		% call fin_txt
	endif
	pop FS:[0]
	add esp,12
	assume FS:error
endm

.data
		AppName			BYTE "ExceptionTest",0
		tText			BYTE "entered guarded area!",0
		fText			BYTE "executing finally block!",0
		xText			BYTE "exited guarded area!",0
		aText			BYTE "EXCEPTION_ACCESS_VIOLATION",0
		dText			BYTE "EXCEPTION_INT_DIVIDE_BY_ZERO",0
		uText			BYTE "unwinding",0
		mem_address		DWORD offset scratch

.data?
		scratch			DWORD ?

.code
start:
		try
			invoke MessageBox,NULL,addr tText,addr AppName,MB_OK
			mov eax,mem_address
			mov DWORD ptr [eax],5
		finally
			invoke MessageBox,NULL,addr fText,addr AppName,MB_OK
		endtry
		invoke MessageBox,NULL,addr xText,addr AppName,MB_OK
		try
			invoke MessageBox,NULL,addr tText,addr AppName,MB_OK
			xor ecx,ecx
			div ecx
		catch EXCEPTION_ACCESS_VIOLATION
			invoke MessageBox,NULL,addr aText,addr AppName,MB_OK
			catch EXCEPTION_INT_DIVIDE_BY_ZERO
			invoke MessageBox,NULL,addr dText,addr AppName,MB_OK
		endtry
		invoke MessageBox,NULL,addr xText,addr AppName,MB_OK
		invoke ExitProcess,0

ExceptionHandler proc C lpExceptionRecord:DWORD,lpEstablisherFrame:DWORD,lpContextRecord:DWORD,lpDispatcherContext:DWORD

		mov ecx,lpExceptionRecord
		test (EXCEPTION_RECORD ptr [ecx]).ExceptionFlags,EH_NONCONTINUABLE
		jnz walkDownTheHandlerChain
			test (EXCEPTION_RECORD ptr [ecx]).ExceptionFlags,EH_UNWINDING or EH_EXIT_UNWIND
			jnz unwind
				push ebp				
				mov edx,lpEstablisherFrame
				mov ebp,(EXCEPTION_REGISTRATION_XTN ptr [edx]).csfEbp
				call (EXCEPTION_REGISTRATION_XTN ptr [edx]).catcherlist
				pop ebp
				or eax,eax
				je walkDownTheHandlerChain				; if eax==EXCEPTION_CONTINUE_SEARCH
					jle continue_execution				; if eax==EXCEPTION_CONTINUE_EXECUTION
						mov eax,offset unwind_ret
						invoke RtlUnwind,lpEstablisherFrame,eax,lpExceptionRecord,0
						unwind_ret:												; unwind abgeschlossen
						mov edx,lpEstablisherFrame
						mov ebp,(EXCEPTION_REGISTRATION_XTN ptr [edx]).csfEbp
						call (EXCEPTION_REGISTRATION_XTN ptr [edx]).catcherlist	; doesn't return if exception is catched
					continue_execution:
					mov eax,ExceptionContinueExecution
					ret
			unwind:
		walkDownTheHandlerChain:
		mov eax,ExceptionContinueSearch
		ret
		
ExceptionHandler endp

end start